Index: uspace/srv/fs/devfs/devfs_ops.c
===================================================================
--- uspace/srv/fs/devfs/devfs_ops.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/fs/devfs/devfs_ops.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -42,17 +42,11 @@
 #include <string.h>
 #include <libfs.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <adt/hash_table.h>
-#include <ipc/devmap.h>
 #include <sys/stat.h>
-#include <libfs.h>
-#include <assert.h>
 #include "devfs.h"
 #include "devfs_ops.h"
 
-typedef struct {
-	devmap_handle_type_t type;
-	dev_handle_t handle;
-} devfs_node_t;
+#define PLB_GET_CHAR(pos)  (devfs_reg.plb_ro[pos % PLB_SIZE])
 
 /** Opened devices structure */
@@ -97,132 +91,240 @@
 };
 
-static int devfs_node_get_internal(fs_node_t **rfn, devmap_handle_type_t type,
-    dev_handle_t handle)
-{
-	devfs_node_t *node = (devfs_node_t *) malloc(sizeof(devfs_node_t));
-	if (node == NULL) {
-		*rfn = NULL;
-		return ENOMEM;
-	}
-	
-	*rfn = (fs_node_t *) malloc(sizeof(fs_node_t));
-	if (*rfn == NULL) {
-		free(node);
-		*rfn = NULL;
-		return ENOMEM;
-	}
-	
-	fs_node_initialize(*rfn);
-	node->type = type;
-	node->handle = handle;
-	
-	(*rfn)->data = node;
-	return EOK;
-}
-
-static int devfs_root_get(fs_node_t **rfn, dev_handle_t dev_handle)
-{
-	return devfs_node_get_internal(rfn, DEV_HANDLE_NONE, 0);
-}
-
-static int devfs_match(fs_node_t **rfn, fs_node_t *pfn, const char *component)
-{
-	devfs_node_t *node = (devfs_node_t *) pfn->data;
-	
-	if (node->handle == 0) {
-		/* Root directory */
-		
-		dev_desc_t *devs;
-		size_t count = devmap_get_namespaces(&devs);
-		
-		if (count > 0) {
-			size_t pos;
-			for (pos = 0; pos < count; pos++) {
-				/* Ignore root namespace */
-				if (str_cmp(devs[pos].name, "") == 0)
-					continue;
+bool devfs_init(void)
+{
+	if (!hash_table_create(&devices, DEVICES_BUCKETS,
+	    DEVICES_KEYS, &devices_ops))
+		return false;
+	
+	if (devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING) < 0)
+		return false;
+	
+	return true;
+}
+
+void devfs_mounted(ipc_callid_t rid, ipc_call_t *request)
+{
+	/* Accept the mount options */
+	ipc_callid_t callid;
+	size_t size;
+	if (!async_data_write_receive(&callid, &size)) {
+		ipc_answer_0(callid, EINVAL);
+		ipc_answer_0(rid, EINVAL);
+		return;
+	}
+	
+	char *opts = malloc(size + 1);
+	if (!opts) {
+		ipc_answer_0(callid, ENOMEM);
+		ipc_answer_0(rid, ENOMEM);
+		return;
+	}
+	
+	ipcarg_t retval = async_data_write_finalize(callid, opts, size);
+	if (retval != EOK) {
+		ipc_answer_0(rid, retval);
+		free(opts);
+		return;
+	}
+	
+	free(opts);
+	
+	ipc_answer_3(rid, EOK, 0, 0, 0);
+}
+
+void devfs_mount(ipc_callid_t rid, ipc_call_t *request)
+{
+	ipc_answer_0(rid, ENOTSUP);
+}
+
+void devfs_lookup(ipc_callid_t rid, ipc_call_t *request)
+{
+	ipcarg_t first = IPC_GET_ARG1(*request);
+	ipcarg_t last = IPC_GET_ARG2(*request);
+	dev_handle_t dev_handle = IPC_GET_ARG3(*request);
+	ipcarg_t lflag = IPC_GET_ARG4(*request);
+	fs_index_t index = IPC_GET_ARG5(*request);
+	
+	/* Hierarchy is flat, no altroot is supported */
+	if (index != 0) {
+		ipc_answer_0(rid, ENOENT);
+		return;
+	}
+	
+	if ((lflag & L_LINK) || (lflag & L_UNLINK)) {
+		ipc_answer_0(rid, ENOTSUP);
+		return;
+	}
+	
+	/* Eat slash */
+	if (PLB_GET_CHAR(first) == '/') {
+		first++;
+		first %= PLB_SIZE;
+	}
+	
+	if (first >= last) {
+		/* Root entry */
+		if (!(lflag & L_FILE))
+			ipc_answer_5(rid, EOK, devfs_reg.fs_handle, dev_handle, 0, 0, 0);
+		else
+			ipc_answer_0(rid, ENOENT);
+	} else {
+		if (!(lflag & L_DIRECTORY)) {
+			size_t len;
+			if (last >= first)
+				len = last - first + 1;
+			else
+				len = first + PLB_SIZE - last + 1;
+			
+			char *name = (char *) malloc(len + 1);
+			if (name == NULL) {
+				ipc_answer_0(rid, ENOMEM);
+				return;
+			}
+			
+			size_t i;
+			for (i = 0; i < len; i++)
+				name[i] = PLB_GET_CHAR(first + i);
+			
+			name[len] = 0;
+			
+			dev_handle_t handle;
+			if (devmap_device_get_handle(name, &handle, 0) != EOK) {
+				free(name);
+				ipc_answer_0(rid, ENOENT);
+				return;
+			}
+			
+			if (lflag & L_OPEN) {
+				unsigned long key[] = {
+					[DEVICES_KEY_HANDLE] = (unsigned long) handle
+				};
 				
-				if (str_cmp(devs[pos].name, component) == 0) {
-					free(devs);
-					return devfs_node_get_internal(rfn, DEV_HANDLE_NAMESPACE, devs[pos].handle);
+				fibril_mutex_lock(&devices_mutex);
+				link_t *lnk = hash_table_find(&devices, key);
+				if (lnk == NULL) {
+					int phone = devmap_device_connect(handle, 0);
+					if (phone < 0) {
+						fibril_mutex_unlock(&devices_mutex);
+						free(name);
+						ipc_answer_0(rid, ENOENT);
+						return;
+					}
+					
+					device_t *dev = (device_t *) malloc(sizeof(device_t));
+					if (dev == NULL) {
+						fibril_mutex_unlock(&devices_mutex);
+						free(name);
+						ipc_answer_0(rid, ENOMEM);
+						return;
+					}
+					
+					dev->handle = handle;
+					dev->phone = phone;
+					dev->refcount = 1;
+					
+					hash_table_insert(&devices, key, &dev->link);
+				} else {
+					device_t *dev = hash_table_get_instance(lnk, device_t, link);
+					dev->refcount++;
 				}
+				fibril_mutex_unlock(&devices_mutex);
 			}
 			
-			free(devs);
-		}
-		
-		/* Search root namespace */
-		dev_handle_t namespace;
-		if (devmap_namespace_get_handle("", &namespace, 0) == EOK) {
-			count = devmap_get_devices(namespace, &devs);
-			
-			if (count > 0) {
-				size_t pos;
-				for (pos = 0; pos < count; pos++) {
-					if (str_cmp(devs[pos].name, component) == 0) {
-						free(devs);
-						return devfs_node_get_internal(rfn, DEV_HANDLE_DEVICE, devs[pos].handle);
-					}
-				}
-				
-				free(devs);
-			}
-		}
-		
-		*rfn = NULL;
-		return EOK;
-	}
-	
-	if (node->type == DEV_HANDLE_NAMESPACE) {
-		/* Namespace directory */
-		
-		dev_desc_t *devs;
-		size_t count = devmap_get_devices(node->handle, &devs);
-		if (count > 0) {
-			size_t pos;
-			for (pos = 0; pos < count; pos++) {
-				if (str_cmp(devs[pos].name, component) == 0) {
-					free(devs);
-					return devfs_node_get_internal(rfn, DEV_HANDLE_DEVICE, devs[pos].handle);
-				}
-			}
-			
-			free(devs);
-		}
-		
-		*rfn = NULL;
-		return EOK;
-	}
-	
-	*rfn = NULL;
-	return EOK;
-}
-
-static int devfs_node_get(fs_node_t **rfn, dev_handle_t dev_handle, fs_index_t index)
-{
-	return devfs_node_get_internal(rfn, devmap_handle_probe(index), index);
-}
-
-static int devfs_node_open(fs_node_t *fn)
-{
-	devfs_node_t *node = (devfs_node_t *) fn->data;
-	
-	if (node->handle == 0) {
-		/* Root directory */
-		return EOK;
-	}
-	
-	devmap_handle_type_t type = devmap_handle_probe(node->handle);
-	
-	if (type == DEV_HANDLE_NAMESPACE) {
-		/* Namespace directory */
-		return EOK;
-	}
-	
-	if (type == DEV_HANDLE_DEVICE) {
-		/* Device node */
-		
+			free(name);
+			
+			ipc_answer_5(rid, EOK, devfs_reg.fs_handle, dev_handle, handle, 0, 1);
+		} else
+			ipc_answer_0(rid, ENOENT);
+	}
+}
+
+void devfs_open_node(ipc_callid_t rid, ipc_call_t *request)
+{
+	dev_handle_t handle = IPC_GET_ARG2(*request);
+	
+	unsigned long key[] = {
+		[DEVICES_KEY_HANDLE] = (unsigned long) handle
+	};
+	
+	fibril_mutex_lock(&devices_mutex);
+	link_t *lnk = hash_table_find(&devices, key);
+	if (lnk == NULL) {
+		int phone = devmap_device_connect(handle, 0);
+		if (phone < 0) {
+			fibril_mutex_unlock(&devices_mutex);
+			ipc_answer_0(rid, ENOENT);
+			return;
+		}
+		
+		device_t *dev = (device_t *) malloc(sizeof(device_t));
+		if (dev == NULL) {
+			fibril_mutex_unlock(&devices_mutex);
+			ipc_answer_0(rid, ENOMEM);
+			return;
+		}
+		
+		dev->handle = handle;
+		dev->phone = phone;
+		dev->refcount = 1;
+		
+		hash_table_insert(&devices, key, &dev->link);
+	} else {
+		device_t *dev = hash_table_get_instance(lnk, device_t, link);
+		dev->refcount++;
+	}
+	fibril_mutex_unlock(&devices_mutex);
+	
+	ipc_answer_3(rid, EOK, 0, 1, L_FILE);
+}
+
+void devfs_stat(ipc_callid_t rid, ipc_call_t *request)
+{
+	dev_handle_t dev_handle = (dev_handle_t) IPC_GET_ARG1(*request);
+	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*request);
+	
+	ipc_callid_t callid;
+	size_t size;
+	if (!async_data_read_receive(&callid, &size) ||
+	    size != sizeof(struct stat)) {
+		ipc_answer_0(callid, EINVAL);
+		ipc_answer_0(rid, EINVAL);
+		return;
+	}
+
+	struct stat stat;
+	memset(&stat, 0, sizeof(struct stat));
+
+	stat.fs_handle = devfs_reg.fs_handle;
+	stat.dev_handle = dev_handle;
+	stat.index = index;
+	stat.lnkcnt = 1;
+	stat.is_file = (index != 0);
+	stat.size = 0;
+	
+	if (index != 0) {
 		unsigned long key[] = {
-			[DEVICES_KEY_HANDLE] = (unsigned long) node->handle
+			[DEVICES_KEY_HANDLE] = (unsigned long) index
+		};
+		
+		fibril_mutex_lock(&devices_mutex);
+		link_t *lnk = hash_table_find(&devices, key);
+		if (lnk != NULL) 
+			stat.devfs_stat.device = (dev_handle_t)index;
+		fibril_mutex_unlock(&devices_mutex);
+	}
+
+	async_data_read_finalize(callid, &stat, sizeof(struct stat));
+	ipc_answer_0(rid, EOK);
+}
+
+void devfs_read(ipc_callid_t rid, ipc_call_t *request)
+{
+	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*request);
+	off_t pos = (off_t) IPC_GET_ARG3(*request);
+	
+	if (index != 0) {
+		unsigned long key[] = {
+			[DEVICES_KEY_HANDLE] = (unsigned long) index
 		};
 		
@@ -230,229 +332,37 @@
 		link_t *lnk = hash_table_find(&devices, key);
 		if (lnk == NULL) {
-			device_t *dev = (device_t *) malloc(sizeof(device_t));
-			if (dev == NULL) {
-				fibril_mutex_unlock(&devices_mutex);
-				return ENOMEM;
-			}
-			
-			int phone = devmap_device_connect(node->handle, 0);
-			if (phone < 0) {
-				fibril_mutex_unlock(&devices_mutex);
-				free(dev);
-				return ENOENT;
-			}
-			
-			dev->handle = node->handle;
-			dev->phone = phone;
-			dev->refcount = 1;
-			
-			hash_table_insert(&devices, key, &dev->link);
-		} else {
-			device_t *dev = hash_table_get_instance(lnk, device_t, link);
-			dev->refcount++;
-		}
-		
+			fibril_mutex_unlock(&devices_mutex);
+			ipc_answer_0(rid, ENOENT);
+			return;
+		}
+		
+		device_t *dev = hash_table_get_instance(lnk, device_t, link);
+		
+		ipc_callid_t callid;
+		if (!async_data_read_receive(&callid, NULL)) {
+			fibril_mutex_unlock(&devices_mutex);
+			ipc_answer_0(callid, EINVAL);
+			ipc_answer_0(rid, EINVAL);
+			return;
+		}
+		
+		/* Make a request at the driver */
+		ipc_call_t answer;
+		aid_t msg = async_send_3(dev->phone, IPC_GET_METHOD(*request),
+		    IPC_GET_ARG1(*request), IPC_GET_ARG2(*request),
+		    IPC_GET_ARG3(*request), &answer);
+		
+		/* Forward the IPC_M_DATA_READ request to the driver */
+		ipc_forward_fast(callid, dev->phone, 0, 0, 0, IPC_FF_ROUTE_FROM_ME);
 		fibril_mutex_unlock(&devices_mutex);
 		
-		return EOK;
-	}
-	
-	return ENOENT;
-}
-
-static int devfs_node_put(fs_node_t *fn)
-{
-	free(fn->data);
-	free(fn);
-	return EOK;
-}
-
-static int devfs_create_node(fs_node_t **rfn, dev_handle_t dev_handle, int lflag)
-{
-	assert((lflag & L_FILE) ^ (lflag & L_DIRECTORY));
-	
-	*rfn = NULL;
-	return ENOTSUP;
-}
-
-static int devfs_destroy_node(fs_node_t *fn)
-{
-	return ENOTSUP;
-}
-
-static int devfs_link_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
-{
-	return ENOTSUP;
-}
-
-static int devfs_unlink_node(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
-{
-	return ENOTSUP;
-}
-
-static int devfs_has_children(bool *has_children, fs_node_t *fn)
-{
-	devfs_node_t *node = (devfs_node_t *) fn->data;
-	
-	if (node->handle == 0) {
-		size_t count = devmap_count_namespaces();
-		if (count > 0) {
-			*has_children = true;
-			return EOK;
-		}
-		
-		/* Root namespace */
-		dev_handle_t namespace;
-		if (devmap_namespace_get_handle("", &namespace, 0) == EOK) {
-			count = devmap_count_devices(namespace);
-			if (count > 0) {
-				*has_children = true;
-				return EOK;
-			}
-		}
-		
-		*has_children = false;
-		return EOK;
-	}
-	
-	if (node->type == DEV_HANDLE_NAMESPACE) {
-		size_t count = devmap_count_devices(node->handle);
-		if (count > 0) {
-			*has_children = true;
-			return EOK;
-		}
-		
-		*has_children = false;
-		return EOK;
-	}
-	
-	*has_children = false;
-	return EOK;
-}
-
-static fs_index_t devfs_index_get(fs_node_t *fn)
-{
-	devfs_node_t *node = (devfs_node_t *) fn->data;
-	return node->handle;
-}
-
-static size_t devfs_size_get(fs_node_t *fn)
-{
-	return 0;
-}
-
-static unsigned int devfs_lnkcnt_get(fs_node_t *fn)
-{
-	devfs_node_t *node = (devfs_node_t *) fn->data;
-	
-	if (node->handle == 0)
-		return 0;
-	
-	return 1;
-}
-
-static char devfs_plb_get_char(unsigned pos)
-{
-	return devfs_reg.plb_ro[pos % PLB_SIZE];
-}
-
-static bool devfs_is_directory(fs_node_t *fn)
-{
-	devfs_node_t *node = (devfs_node_t *) fn->data;
-	
-	return ((node->type == DEV_HANDLE_NONE) || (node->type == DEV_HANDLE_NAMESPACE));
-}
-
-static bool devfs_is_file(fs_node_t *fn)
-{
-	devfs_node_t *node = (devfs_node_t *) fn->data;
-	
-	return (node->type == DEV_HANDLE_DEVICE);
-}
-
-static dev_handle_t devfs_device_get(fs_node_t *fn)
-{
-	devfs_node_t *node = (devfs_node_t *) fn->data;
-	
-	if (node->type == DEV_HANDLE_DEVICE)
-		return node->handle;
-	
-	return 0;
-}
-
-/** libfs operations */
-libfs_ops_t devfs_libfs_ops = {
-	.root_get = devfs_root_get,
-	.match = devfs_match,
-	.node_get = devfs_node_get,
-	.node_open = devfs_node_open,
-	.node_put = devfs_node_put,
-	.create = devfs_create_node,
-	.destroy = devfs_destroy_node,
-	.link = devfs_link_node,
-	.unlink = devfs_unlink_node,
-	.has_children = devfs_has_children,
-	.index_get = devfs_index_get,
-	.size_get = devfs_size_get,
-	.lnkcnt_get = devfs_lnkcnt_get,
-	.plb_get_char = devfs_plb_get_char,
-	.is_directory = devfs_is_directory,
-	.is_file = devfs_is_file,
-	.device_get = devfs_device_get
-};
-
-bool devfs_init(void)
-{
-	if (!hash_table_create(&devices, DEVICES_BUCKETS,
-	    DEVICES_KEYS, &devices_ops))
-		return false;
-	
-	if (devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING) < 0)
-		return false;
-	
-	return true;
-}
-
-void devfs_mounted(ipc_callid_t rid, ipc_call_t *request)
-{
-	char *opts;
-	
-	/* Accept the mount options */
-	ipcarg_t retval = async_data_string_receive(&opts, 0);
-	if (retval != EOK) {
-		ipc_answer_0(rid, retval);
-		return;
-	}
-	
-	free(opts);
-	ipc_answer_3(rid, EOK, 0, 0, 0);
-}
-
-void devfs_mount(ipc_callid_t rid, ipc_call_t *request)
-{
-	libfs_mount(&devfs_libfs_ops, devfs_reg.fs_handle, rid, request);
-}
-
-void devfs_lookup(ipc_callid_t rid, ipc_call_t *request)
-{
-	libfs_lookup(&devfs_libfs_ops, devfs_reg.fs_handle, rid, request);
-}
-
-void devfs_open_node(ipc_callid_t rid, ipc_call_t *request)
-{
-	libfs_open_node(&devfs_libfs_ops, devfs_reg.fs_handle, rid, request);
-}
-
-void devfs_stat(ipc_callid_t rid, ipc_call_t *request)
-{
-	libfs_stat(&devfs_libfs_ops, devfs_reg.fs_handle, rid, request);
-}
-
-void devfs_read(ipc_callid_t rid, ipc_call_t *request)
-{
-	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*request);
-	off_t pos = (off_t) IPC_GET_ARG3(*request);
-	
-	if (index == 0) {
+		/* Wait for reply from the driver. */
+		ipcarg_t rc;
+		async_wait_for(msg, &rc);
+		size_t bytes = IPC_GET_ARG1(answer);
+		
+		/* Driver reply is the final result of the whole operation */
+		ipc_answer_1(rid, rc, bytes);
+	} else {
 		ipc_callid_t callid;
 		size_t size;
@@ -463,79 +373,34 @@
 		}
 		
-		dev_desc_t *desc;
-		size_t count = devmap_get_namespaces(&desc);
-		
-		/* Get rid of root namespace */
-		size_t i;
-		for (i = 0; i < count; i++) {
-			if (str_cmp(desc[i].name, "") == 0) {
-				if (pos >= i)
-					pos++;
-				
-				break;
-			}
-		}
-		
-		if (pos < count) {
+		size_t count = devmap_device_get_count();
+		dev_desc_t *desc = malloc(count * sizeof(dev_desc_t));
+		if (desc == NULL) {
+			ipc_answer_0(callid, ENOMEM);
+			ipc_answer_1(rid, ENOMEM, 0);
+			return;
+		}
+		
+		size_t max = devmap_device_get_devices(count, desc);
+		
+		if (pos < max) {
 			async_data_read_finalize(callid, desc[pos].name, str_size(desc[pos].name) + 1);
-			free(desc);
-			ipc_answer_1(rid, EOK, 1);
+		} else {
+			ipc_answer_0(callid, ENOENT);
+			ipc_answer_1(rid, ENOENT, 0);
 			return;
 		}
 		
 		free(desc);
-		pos -= count;
-		
-		/* Search root namespace */
-		dev_handle_t namespace;
-		if (devmap_namespace_get_handle("", &namespace, 0) == EOK) {
-			count = devmap_get_devices(namespace, &desc);
-			
-			if (pos < count) {
-				async_data_read_finalize(callid, desc[pos].name, str_size(desc[pos].name) + 1);
-				free(desc);
-				ipc_answer_1(rid, EOK, 1);
-				return;
-			}
-			
-			free(desc);
-		}
-		
-		ipc_answer_0(callid, ENOENT);
-		ipc_answer_1(rid, ENOENT, 0);
-		return;
-	}
-	
-	devmap_handle_type_t type = devmap_handle_probe(index);
-	
-	if (type == DEV_HANDLE_NAMESPACE) {
-		/* Namespace directory */
-		ipc_callid_t callid;
-		size_t size;
-		if (!async_data_read_receive(&callid, &size)) {
-			ipc_answer_0(callid, EINVAL);
-			ipc_answer_0(rid, EINVAL);
-			return;
-		}
-		
-		dev_desc_t *desc;
-		size_t count = devmap_get_devices(index, &desc);
-		
-		if (pos < count) {
-			async_data_read_finalize(callid, desc[pos].name, str_size(desc[pos].name) + 1);
-			free(desc);
-			ipc_answer_1(rid, EOK, 1);
-			return;
-		}
-		
-		free(desc);
-		ipc_answer_0(callid, ENOENT);
-		ipc_answer_1(rid, ENOENT, 0);
-		return;
-	}
-	
-	if (type == DEV_HANDLE_DEVICE) {
-		/* Device node */
-		
+		
+		ipc_answer_1(rid, EOK, 1);
+	}
+}
+
+void devfs_write(ipc_callid_t rid, ipc_call_t *request)
+{
+	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*request);
+	off_t pos = (off_t) IPC_GET_ARG3(*request);
+	
+	if (index != 0) {
 		unsigned long key[] = {
 			[DEVICES_KEY_HANDLE] = (unsigned long) index
@@ -553,5 +418,5 @@
 		
 		ipc_callid_t callid;
-		if (!async_data_read_receive(&callid, NULL)) {
+		if (!async_data_write_receive(&callid, NULL)) {
 			fibril_mutex_unlock(&devices_mutex);
 			ipc_answer_0(callid, EINVAL);
@@ -566,6 +431,7 @@
 		    IPC_GET_ARG3(*request), &answer);
 		
-		/* Forward the IPC_M_DATA_READ request to the driver */
+		/* Forward the IPC_M_DATA_WRITE request to the driver */
 		ipc_forward_fast(callid, dev->phone, 0, 0, 0, IPC_FF_ROUTE_FROM_ME);
+		
 		fibril_mutex_unlock(&devices_mutex);
 		
@@ -577,30 +443,20 @@
 		/* Driver reply is the final result of the whole operation */
 		ipc_answer_1(rid, rc, bytes);
-		return;
-	}
-	
-	ipc_answer_0(rid, ENOENT);
-}
-
-void devfs_write(ipc_callid_t rid, ipc_call_t *request)
+	} else {
+		/* Read-only filesystem */
+		ipc_answer_0(rid, ENOTSUP);
+	}
+}
+
+void devfs_truncate(ipc_callid_t rid, ipc_call_t *request)
+{
+	ipc_answer_0(rid, ENOTSUP);
+}
+
+void devfs_close(ipc_callid_t rid, ipc_call_t *request)
 {
 	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*request);
-	off_t pos = (off_t) IPC_GET_ARG3(*request);
-	
-	if (index == 0) {
-		ipc_answer_0(rid, ENOTSUP);
-		return;
-	}
-	
-	devmap_handle_type_t type = devmap_handle_probe(index);
-	
-	if (type == DEV_HANDLE_NAMESPACE) {
-		/* Namespace directory */
-		ipc_answer_0(rid, ENOTSUP);
-		return;
-	}
-	
-	if (type == DEV_HANDLE_DEVICE) {
-		/* Device node */
+	
+	if (index != 0) {
 		unsigned long key[] = {
 			[DEVICES_KEY_HANDLE] = (unsigned long) index
@@ -616,73 +472,4 @@
 		
 		device_t *dev = hash_table_get_instance(lnk, device_t, link);
-		
-		ipc_callid_t callid;
-		if (!async_data_write_receive(&callid, NULL)) {
-			fibril_mutex_unlock(&devices_mutex);
-			ipc_answer_0(callid, EINVAL);
-			ipc_answer_0(rid, EINVAL);
-			return;
-		}
-		
-		/* Make a request at the driver */
-		ipc_call_t answer;
-		aid_t msg = async_send_3(dev->phone, IPC_GET_METHOD(*request),
-		    IPC_GET_ARG1(*request), IPC_GET_ARG2(*request),
-		    IPC_GET_ARG3(*request), &answer);
-		
-		/* Forward the IPC_M_DATA_WRITE request to the driver */
-		ipc_forward_fast(callid, dev->phone, 0, 0, 0, IPC_FF_ROUTE_FROM_ME);
-		
-		fibril_mutex_unlock(&devices_mutex);
-		
-		/* Wait for reply from the driver. */
-		ipcarg_t rc;
-		async_wait_for(msg, &rc);
-		size_t bytes = IPC_GET_ARG1(answer);
-		
-		/* Driver reply is the final result of the whole operation */
-		ipc_answer_1(rid, rc, bytes);
-		return;
-	}
-	
-	ipc_answer_0(rid, ENOENT);
-}
-
-void devfs_truncate(ipc_callid_t rid, ipc_call_t *request)
-{
-	ipc_answer_0(rid, ENOTSUP);
-}
-
-void devfs_close(ipc_callid_t rid, ipc_call_t *request)
-{
-	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*request);
-	
-	if (index == 0) {
-		ipc_answer_0(rid, EOK);
-		return;
-	}
-	
-	devmap_handle_type_t type = devmap_handle_probe(index);
-	
-	if (type == DEV_HANDLE_NAMESPACE) {
-		/* Namespace directory */
-		ipc_answer_0(rid, EOK);
-		return;
-	}
-	
-	if (type == DEV_HANDLE_DEVICE) {
-		unsigned long key[] = {
-			[DEVICES_KEY_HANDLE] = (unsigned long) index
-		};
-		
-		fibril_mutex_lock(&devices_mutex);
-		link_t *lnk = hash_table_find(&devices, key);
-		if (lnk == NULL) {
-			fibril_mutex_unlock(&devices_mutex);
-			ipc_answer_0(rid, ENOENT);
-			return;
-		}
-		
-		device_t *dev = hash_table_get_instance(lnk, device_t, link);
 		dev->refcount--;
 		
@@ -695,8 +482,6 @@
 		
 		ipc_answer_0(rid, EOK);
-		return;
-	}
-	
-	ipc_answer_0(rid, ENOENT);
+	} else
+		ipc_answer_0(rid, ENOTSUP);
 }
 
@@ -705,18 +490,5 @@
 	fs_index_t index = (fs_index_t) IPC_GET_ARG2(*request);
 	
-	if (index == 0) {
-		ipc_answer_0(rid, EOK);
-		return;
-	}
-	
-	devmap_handle_type_t type = devmap_handle_probe(index);
-	
-	if (type == DEV_HANDLE_NAMESPACE) {
-		/* Namespace directory */
-		ipc_answer_0(rid, EOK);
-		return;
-	}
-	
-	if (type == DEV_HANDLE_DEVICE) {
+	if (index != 0) {
 		unsigned long key[] = {
 			[DEVICES_KEY_HANDLE] = (unsigned long) index
@@ -746,8 +518,6 @@
 		/* Driver reply is the final result of the whole operation */
 		ipc_answer_0(rid, rc);
-		return;
-	}
-	
-	ipc_answer_0(rid, ENOENT);
+	} else
+		ipc_answer_0(rid, ENOTSUP);
 }
 
Index: uspace/srv/fs/fat/fat.h
===================================================================
--- uspace/srv/fs/fat/fat.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/fs/fat/fat.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,5 +36,5 @@
 #include "fat_fat.h"
 #include <ipc/ipc.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <libfs.h>
 #include <atomic.h>
Index: uspace/srv/fs/fat/fat_fat.c
===================================================================
--- uspace/srv/fs/fat/fat_fat.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/fs/fat/fat_fat.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -46,5 +46,5 @@
 #include <align.h>
 #include <assert.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <mem.h>
 
Index: uspace/srv/fs/fat/fat_idx.c
===================================================================
--- uspace/srv/fs/fat/fat_idx.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/fs/fat/fat_idx.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -43,5 +43,5 @@
 #include <adt/list.h>
 #include <assert.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 
 /** Each instance of this type describes one interval of freed VFS indices. */
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/fs/fat/fat_ops.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -52,5 +52,5 @@
 #include <adt/list.h>
 #include <assert.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <sys/mman.h>
 #include <align.h>
@@ -71,5 +71,4 @@
 static int fat_match(fs_node_t **, fs_node_t *, const char *);
 static int fat_node_get(fs_node_t **, dev_handle_t, fs_index_t);
-static int fat_node_open(fs_node_t *);
 static int fat_node_put(fs_node_t *);
 static int fat_create_node(fs_node_t **, dev_handle_t, int);
@@ -84,5 +83,4 @@
 static bool fat_is_directory(fs_node_t *);
 static bool fat_is_file(fs_node_t *node);
-static dev_handle_t fat_device_get(fs_node_t *node);
 
 /*
@@ -409,13 +407,4 @@
 }
 
-int fat_node_open(fs_node_t *fn)
-{
-	/*
-	 * Opening a file is stateless, nothing
-	 * to be done here.
-	 */
-	return EOK;
-}
-
 int fat_node_put(fs_node_t *fn)
 {
@@ -878,9 +867,4 @@
 }
 
-dev_handle_t fat_device_get(fs_node_t *node)
-{
-	return 0;
-}
-
 /** libfs operations */
 libfs_ops_t fat_libfs_ops = {
@@ -888,5 +872,4 @@
 	.match = fat_match,
 	.node_get = fat_node_get,
-	.node_open = fat_node_open,
 	.node_put = fat_node_put,
 	.create = fat_create_node,
@@ -898,8 +881,7 @@
 	.size_get = fat_size_get,
 	.lnkcnt_get = fat_lnkcnt_get,
-	.plb_get_char = fat_plb_get_char,
+	.plb_get_char =	fat_plb_get_char,
 	.is_directory = fat_is_directory,
-	.is_file = fat_is_file,
-	.device_get = fat_device_get
+	.is_file = fat_is_file
 };
 
Index: uspace/srv/fs/tmpfs/tmpfs_ops.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs_ops.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/fs/tmpfs/tmpfs_ops.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -69,5 +69,4 @@
 static int tmpfs_match(fs_node_t **, fs_node_t *, const char *);
 static int tmpfs_node_get(fs_node_t **, dev_handle_t, fs_index_t);
-static int tmpfs_node_open(fs_node_t *);
 static int tmpfs_node_put(fs_node_t *);
 static int tmpfs_create_node(fs_node_t **, dev_handle_t, int);
@@ -118,9 +117,4 @@
 }
 
-static dev_handle_t tmpfs_device_get(fs_node_t *fn)
-{
-	return 0;
-}
-
 /** libfs operations */
 libfs_ops_t tmpfs_libfs_ops = {
@@ -128,5 +122,4 @@
 	.match = tmpfs_match,
 	.node_get = tmpfs_node_get,
-	.node_open = tmpfs_node_open,
 	.node_put = tmpfs_node_put,
 	.create = tmpfs_create_node,
@@ -140,6 +133,5 @@
 	.plb_get_char = tmpfs_plb_get_char,
 	.is_directory = tmpfs_is_directory,
-	.is_file = tmpfs_is_file,
-	.device_get = tmpfs_device_get
+	.is_file = tmpfs_is_file
 };
 
@@ -249,10 +241,4 @@
 	}
 	return EOK;	
-}
-
-int tmpfs_node_open(fs_node_t *fn)
-{
-	/* nothing to do */
-	return EOK;
 }
 
Index: uspace/srv/kbd/generic/kbd.c
===================================================================
--- uspace/srv/kbd/generic/kbd.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/kbd/generic/kbd.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -50,5 +50,4 @@
 #include <io/console.h>
 #include <io/keycode.h>
-#include <devmap.h>
 
 #include <kbd.h>
@@ -57,7 +56,7 @@
 #include <layout.h>
 
-#define NAME       "kbd"
-#define NAMESPACE  "hid_in"
-
+#define NAME "kbd"
+
+int cons_connected = 0;
 int phone2cons = -1;
 
@@ -173,4 +172,9 @@
 	int retval;
 
+	if (cons_connected) {
+		ipc_answer_0(iid, ELIMIT);
+		return;
+	}
+	cons_connected = 1;
 	ipc_answer_0(iid, EOK);
 
@@ -179,9 +183,7 @@
 		switch (IPC_GET_METHOD(call)) {
 		case IPC_M_PHONE_HUNGUP:
-			if (phone2cons != -1) {
-				ipc_hangup(phone2cons);
-				phone2cons = -1;
-			}
-			
+			cons_connected = 0;
+			ipc_hangup(phone2cons);
+			phone2cons = -1;
 			ipc_answer_0(callid, EOK);
 			return;
@@ -214,4 +216,6 @@
 	printf(NAME ": HelenOS Keyboard service\n");
 	
+	ipcarg_t phonead;
+	
 	if (sysinfo_value("kbd.cir.fhc") == 1)
 		cir_service = SERVICE_FHC;
@@ -237,20 +241,10 @@
 	layout[active_layout]->reset();
 	
-	/* Register driver */
-	int rc = devmap_driver_register(NAME, console_connection);
-	if (rc < 0) {
-		printf(NAME ": Unable to register driver (%d)\n", rc);
+	async_set_client_connection(console_connection);
+
+	/* Register service at nameserver. */
+	if (ipc_connect_to_me(PHONE_NS, SERVICE_KEYBOARD, 0, 0, &phonead) != 0)
 		return -1;
-	}
-	
-	char kbd[DEVMAP_NAME_MAXLEN + 1];
-	snprintf(kbd, DEVMAP_NAME_MAXLEN, "%s/%s", NAMESPACE, NAME);
-	
-	dev_handle_t dev_handle;
-	if (devmap_device_register(kbd, &dev_handle) != EOK) {
-		printf(NAME ": Unable to register device %s\n", kbd);
-		return -1;
-	}
-
+	
 	printf(NAME ": Accepting connections\n");
 	async_manager();
Index: uspace/srv/loader/arch/arm32/arm32.s
===================================================================
--- uspace/srv/loader/arch/arm32/arm32.s	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/loader/arch/arm32/arm32.s	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,7 +36,4 @@
 # Jump to a program entry point
 program_run:
-	# load ras_page address to r2
-	ldr r2, =ras_page
-	ldr r2, [r2]
 	# pcb is passed to the entry point in r1 (where it already is)
 	mov r15, r0
Index: uspace/srv/part/mbr_part/mbr_part.c
===================================================================
--- uspace/srv/part/mbr_part/mbr_part.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/part/mbr_part/mbr_part.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -61,5 +61,5 @@
 #include <async.h>
 #include <as.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <devmap.h>
 #include <sys/types.h>
Index: uspace/srv/vfs/vfs.h
===================================================================
--- uspace/srv/vfs/vfs.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/vfs/vfs.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,5 +36,5 @@
 #include <ipc/ipc.h>
 #include <adt/list.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <sys/types.h>
 #include <devmap.h>
Index: uspace/srv/vfs/vfs_file.c
===================================================================
--- uspace/srv/vfs/vfs_file.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/vfs/vfs_file.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -42,5 +42,5 @@
 #include <bool.h>
 #include <fibril.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include "vfs.h"
 
@@ -89,5 +89,5 @@
 	unsigned int i;
 	if (desc)
-		i = MAX_OPEN_FILES - 1;
+		i = MAX_OPEN_FILES;
 	else
 		i = 0;
@@ -111,5 +111,5 @@
 			i--;
 		} else {
-			if (i == MAX_OPEN_FILES - 1)
+			if (i == MAX_OPEN_FILES)
 				break;
 			
Index: uspace/srv/vfs/vfs_lookup.c
===================================================================
--- uspace/srv/vfs/vfs_lookup.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/vfs/vfs_lookup.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -43,5 +43,5 @@
 #include <stdarg.h>
 #include <bool.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <adt/list.h>
 #include <vfs/canonify.h>
Index: uspace/srv/vfs/vfs_node.c
===================================================================
--- uspace/srv/vfs/vfs_node.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/vfs/vfs_node.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -39,5 +39,5 @@
 #include <stdlib.h>
 #include <string.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <adt/hash_table.h>
 #include <assert.h>
Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/vfs/vfs_ops.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -44,5 +44,5 @@
 #include <string.h>
 #include <bool.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <adt/list.h>
 #include <unistd.h>
Index: uspace/srv/vfs/vfs_register.c
===================================================================
--- uspace/srv/vfs/vfs_register.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/srv/vfs/vfs_register.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -46,5 +46,5 @@
 #include <ctype.h>
 #include <bool.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <adt/list.h>
 #include <as.h>
